// ONSPlus: Coded by Shambler (Shambler__@Hotmail.com or Shambler@OldUnreal.com , ICQ:108730864)
Class ONSPlusAttackCraftMissle extends ONSAttackCraftMissle;

var vehicle DelLockOnTarget;
delegate DelNotifyPlusEnemyLostLock(optional actor UnLockedActor);
delegate DelNotifyPlusEnemyLockedOn(actor LockedActor);

simulated function Destroyed()
{
	if (TrailEmitter != None)
		TrailEmitter.Destroy();

	if (Role == ROLE_Authority && HomingTarget != None)
		GiveLostLockNotification(HomingTarget);

	Super(Projectile).Destroyed();
}

function SetHomingTarget(Vehicle NewTarget)
{
	if (HomingTarget != None)
		GiveLostLockNotification(HomingTarget);

	HomingTarget = NewTarget;

	if (HomingTarget != None)
		GiveLockedOnNotification(HomingTarget);
}

simulated function Timer()
{
	local float VelMag;
	local vector ForceDir;

	if (HomingTarget == None)
		return;

	ForceDir = Normal(HomingTarget.Location - Location);

	if (ForceDir dot InitialDir > 0)
	{
	    	// Do normal guidance to target.
		VelMag = VSize(Velocity);

		ForceDir = Normal(ForceDir * 0.7 * VelMag + Velocity);
		Velocity =  VelMag * ForceDir;
		Acceleration = Normal(Velocity) * AccelRate;

		// Update rocket so it faces in the direction its going.
		SetRotation(rotator(Velocity));
	}
	else
	{
		GiveLostLockNotification(HomingTarget);
		HomingTarget = None;
	}
}

function GiveLostLockNotification(vehicle V)
{
	if (ONSPlusHoverBike(V) != None)
	{
		ONSPlusHoverBike(V).NotifyPlusEnemyLostLock(Self);
	}
	else if (ONSPlusAttackCraft(V) != None)
	{
		ONSPlusAttackCraft(V).NotifyPlusEnemyLostLock(Self);
	}
	else if (ONSPlusPRV(V) != None)
	{
		ONSPlusPRV(V).NotifyPlusEnemyLostLock(Self);
	}
	else if (ONSPlusRV(V) != None)
	{
		ONSPlusRV(V).NotifyPlusEnemyLostLock(Self);
	}
	else if (ONSPlusMobileAssaultStation(V) != None)
	{
		ONSPlusMobileAssaultStation(V).NotifyPlusEnemyLostLock(Self);
	}
	else if (ONSPlusHoverTank(V) != None)
	{
		ONSPlusHoverTank(V).NotifyPlusEnemyLostLock(Self);
	}
	else if (ONSPlusArtillery(V) != None)
	{
		ONSPlusArtillery(V).NotifyPlusEnemyLostLock(Self);
	}
	else if (ONSPlusDualAttackCraft(V) != None)
	{
		ONSPlusDualAttackCraft(V).NotifyPlusEnemyLostLock(Self);
	}
	else if (ONSPlusShockTank(V) != None)
	{
		ONSPlusShockTank(V).NotifyPlusEnemyLostLock(Self);
	}
	else if (ONSPlusManualGunPawn(V) != None)
	{
		ONSPlusManualGunPawn(V).NotifyPlusEnemyLostLock(Self);
	}
	else if (InstigatorController != none && ONSPlusxPlayer(InstigatorController) != none
		&& ONSPlusxPlayer(InstigatorController).bInitializedClientPlugins && DelLockOnTarget == V)
	{
		DelNotifyPlusEnemyLostLock(Self);
	}
	else
	{
		V.NotifyEnemyLostLock();
	}
}

function GiveLockedOnNotification(vehicle V)
{
	local int i;

	if (ONSPlusHoverBike(V) != None)
	{
		ONSPlusHoverBike(V).NotifyPlusEnemyLockedOn(Self);
	}
	else if (ONSPlusAttackCraft(V) != None)
	{
		ONSPlusAttackCraft(V).NotifyPlusEnemyLockedOn(Self);
	}
	else if (ONSPlusPRV(V) != None)
	{
		ONSPlusPRV(V).NotifyPlusEnemyLockedOn(Self);
	}
	else if (ONSPlusRV(V) != None)
	{
		ONSPlusRV(V).NotifyPlusEnemyLockedOn(Self);
	}
	else if (ONSPlusMobileAssaultStation(V) != None)
	{
		ONSPlusMobileAssaultStation(V).NotifyPlusEnemyLockedOn(Self);
	}
	else if (ONSPlusHoverTank(V) != None)
	{
		ONSPlusHoverTank(V).NotifyPlusEnemyLockedOn(Self);
	}
	else if (ONSPlusArtillery(V) != None)
	{
		ONSPlusArtillery(V).NotifyPlusEnemyLockedOn(Self);
	}
	else if (ONSPlusDualAttackCraft(V) != None)
	{
		ONSPlusDualAttackCraft(V).NotifyPlusEnemyLockedOn(Self);
	}
	else if (ONSPlusShockTank(V) != None)
	{
		ONSPlusShockTank(V).NotifyPlusEnemyLockedOn(Self);
	}
	else if (ONSPlusManualGunPawn(V) != None)
	{
		ONSPlusManualGunPawn(V).NotifyPlusEnemyLockedOn(Self);
	}
	else if (InstigatorController != none && ONSPlusxPlayer(InstigatorController) != none
		&& ONSPlusxPlayer(InstigatorController).bInitializedClientPlugins)
	{
		if (DelLockOnTarget != V)
		{
			for (i=0; i<ONSPlusxPlayer(InstigatorController).VehiclePlugins.Length; ++i)
			{
				if (ONSPlusxPlayer(InstigatorController).VehiclePlugins[i].static.SetupVehicleDelegates(None, None, Self, V))
				{
					DelLockOnTarget = V;
					break;
				}
			}
		}

		if (DelLockOnTarget == V)
			DelNotifyPlusEnemyLockedOn(Self);
		else
			V.NotifyEnemyLockedOn();
	}
	else
	{
		V.NotifyEnemyLockedOn();
	}
}