Class ONSPlusMortarCamera extends ONSMortarCamera;

simulated function Tick(float DT)
{
	local actor HitActor;
	local vector HitNormal, HitLocation;
	local Controller C;
	local Bot B;

	Super(ONSMortarShell).Tick(DT);

	// Shambler: Test fix for non-stop exploding mortar cameras
	if (Role == ROLE_Authority && (Instigator == None || ONSArtillery(Instigator) == None || ONSArtillery(Instigator).Driver == None))
	{
		bShotDown = True;
		ShotDown();
	}


	if (Level.TimeSeconds - MessageUpdateTime > 2.0)
	{
		if (Instigator != None && Instigator.Controller != None && Instigator.Controller == Level.GetLocalPlayerController() && Level.GetLocalPlayerController().ViewTarget == self)
		{
			if (bDeployed)
				PlayerController(Instigator.Controller).ReceiveLocalizedMessage(class'ONSOnslaughtMessage', 33);
			else
				PlayerController(Instigator.Controller).ReceiveLocalizedMessage(class'ONSOnslaughtMessage', 34);
		}

		MessageUpdateTime = Level.TimeSeconds;
	}

	if (!bDeployed)
	{
		SetRotation(Rotator(Velocity));

		if (Instigator != None && AIController(Instigator.Controller) != None && Velocity.Z <= 0)
		{
			if (MaxHeight == 0)
			{
				MaxHeight = Location.Z;
				DeployRand = FRand();

				if (DeployRand < 0.5)
					DeployRand = 1;
			}

			if (Location.Z - TargetZ > (0.2 + 0.8*DeployRand) * (MaxHeight - TargetZ))
				return;

			HitActor = Trace(HitLocation, HitNormal, Instigator.Controller.Target.Location, Location, false);

			if (HitActor == None)
				Deploy();
		}
	}
	else if (Level.TimeSeconds - AnnounceTargetTime > 1.0 && Role == ROLE_Authority)
	{
		if (Instigator == None || Instigator.Controller == None || ONSArtilleryCannon(Owner) == None)
		{
			Disable('Tick');
			return;
		}

		AnnounceTargetTime = Level.TimeSeconds;

		if (!bShotDown)
		{
			for (C=Level.ControllerList; C!=None; C=C.NextController)
			{
				B = Bot(C);

				if (B != None && !B.SameTeamAs(Instigator.Controller) && B.Pawn != None && !B.Pawn.IsFiring() && (B.Enemy == None || B.Enemy == Instigator || !B.EnemyVisible()) &&
					B.LineOfSightTo(self))
				{
					// give B a chance to shoot at me
					B.GoalString = "Destroy Mortar Camera";
					B.Target = self;
					B.SwitchToBestWeapon();

					if (B.Pawn.CanAttack(self))
					{
						B.DoRangedAttackOn(self);

						if (FRand() < 0.5)
							break;
					}
				}
			}
		}
	}

	if (Instigator != None && Instigator.Controller == Level.GetLocalPlayerController() && ONSArtilleryCannon(Owner) != None && Level.TimeSeconds - TargetUpdateTime > 0.1)
	{
		// Target Prediction
		TargetUpdateTime = Level.TimeSeconds;
		ONSArtilleryCannon(Owner).PredictTarget();
	}
}